#include <acl.c>
#include "tl9buitin.c"

#ifdef AUSE_HLX
	regVarOpt(0, i, l, x, y, squar, p1x, p1y, p0x);	// for spd.
	regVarOpt(1, i, l, x, y, squar, p1x, p1y, p0x);	// for siz.
#endif

AWindow *w;
int vertx[8] ={ 2, 2, 2, 2, 0, 0, 0, 0 };
int verty[8] ={ 2, 2, 0, 0, 2, 2, 0, 0 };
int vertz[8] ={ 2, 0, 2, 0, 2, 0, 2, 0 };
int squar[24] = { 0,4,6,2, 1,3,7,5, 0,2,3,1, 0,1,5,4, 4,5,7,6, 6,7,3,2 };
int col[6] = { 0xff0000, 0x00ff00, 0xffff00, 0x0000ff, 0xff00ff, 0x00ffff };

void aMain()
{
	int vx[8]; int vy[8]; int vz[8];
	int centerz4[6];
	int scx[8]; int scy[8];
	int buf0[160]; int buf1[160];
	int i, j, k, l, thx, thy, thz, xp, xa, yp, ya, zp, za, xt, yt, zt, t, m;
	int k0, k1, k2, e0x, e0y, e1x, e1y, l1, p0x, p0y, p1x, p1y, ymin, ymax, x, y, c;
	int dx, *buf, y0, y1;
	w = aOpenWin(256, 160, "graphics", 1);
	for (i = 0; i < 8; i++) {
		vertx[i] = (vertx[i] - 1) * 50;
		verty[i] = (verty[i] - 1) * 50;
		vertz[i] = (vertz[i] - 1) * 50;
	}
	thx = thy = thz = 0;
	for (;;) {
		thx = (thx + 182) & 0xffff;
		thy = (thy + 273) & 0xffff;
		thz = (thz + 364) & 0xffff;
		xp = ff16cos(thx); xa = ff16sin(thx);
		yp = ff16cos(thy); ya = ff16sin(thy);
		zp = ff16cos(thz); za = ff16sin(thz);
		for (i = 0; i < 8; i++) {
			zt = vertz[i] * xp           + verty[i] * xa;
			yt = verty[i] * xp           - vertz[i] * xa;
			xt = vertx[i] * yp           + mul64shr(zt, ya, 16);
			vz[i] = mul64shr(zt, yp, 16) - vertx[i] * ya;
			vx[i] = mul64shr(xt, zp, 16) - mul64shr(yt, za, 16);
			vy[i] = mul64shr(yt, zp, 16) + mul64shr(xt, za, 16);
		}
		for (l = i = 0; i < 6; i++) {
			centerz4[i] = vz[squar[l]] + vz[squar[l + 1]] + vz[squar[l + 2]] + vz[squar[l + 3]] + 0x70000000;
			l = l + 4;
		}
		aFillRect0(w, 160, 160, 48, 0, 0x000000);
		for (i = 0; i < 8; i++) {
			t = (vz[i]+13107200) >> 16;
			t = 4915200 / t;
			scx[i] = mul64shr(vx[i], t, 31) + 128;
			scy[i] = mul64shr(vy[i], t, 31) +  80;
		}
		for (;;) {
			m = j = 0;
			for (i = 0; i < 6; i++) {
				t = centerz4[i];
				if (m < t) {
					m = t;
					j = i;
				}
			}
			if (m == 0) break;
			l = j * 4; centerz4[j] = 0;
			k0 = squar[l];
			k1 = squar[l + 1];
			k2 = squar[l + 2];
			e0x = vx[k1] - vx[k0];
			e0y = vy[k1] - vy[k0];
			e1x = vx[k2] - vx[k1];
			e1y = vy[k2] - vy[k1];
			if (mul64shr(e0x, e1y, 16) <= mul64shr(e0y, e1x, 16)) {
				l1 = l + 4;
				k = squar[l + 3];
				p0x = scx[k]; p0y = scy[k];
				ymin = 99999; ymax = 0;
				for (; l < l1; l++) {
					k = squar[l];
					p1x = scx[k]; p1y = scy[k];
					if (ymin > p1y) { ymin = p1y; }
					if (ymax < p1y) { ymax = p1y; }
					if (p0y != p1y) {
						if (p0y < p1y) {
							buf = buf0; y0 = p0y; y1 = p1y; dx = p1x - p0x; x = p0x;
						} else {
							buf = buf1; y0 = p1y; y1 = p0y; dx = p0x - p1x; x = p1x;
						}
						x = x * 65536;
						dx = dx * 65536;
						dx = dx / (y1 - y0);
						if (dx >= 0) {
							x = x + 0x8000;
						} else {
							x = x - 0x8000;
						}
						++y1;
						for (y = y0; y < y1; y++) {
							buf[y] = x >> 16;
							x = x + dx;
						}
					}
					p0x = p1x; p0y = p1y;
				}
				c = col[j];
				++ymax;
				for (y = ymin; y < ymax; y++) {
					p0x = buf0[y];
					p1x = buf1[y];
					if (p0x <= p1x) {
						aFillRect0(w, p1x - p0x + 1, 1, p0x, y, c);
					} else {
						aFillRect0(w, p0x - p1x + 1, 1, p1x, y, c);
					}
				}
			}
		}
		aWait(50);
		if (aInkey(w, 1) != 0) break;
	}
}
